/*
This file is part of Adapa (Automatic DAta PArallelism)
Copyright (C) 2009  Pedro Ribeiro (CRACS & INESC-Porto LA, U. Porto)

Adapa is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License version 3, as
published by the Free Software Foundation.

Adapa is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Adapa.  If not, see <http://www.gnu.org/licenses/>.
*/
 
#include <stdio.h>
#include <stdlib.h>

#include "Common.h"
#include "Action.h"
#include "Parameters.h"

Parameters p;

// --------------------------------------

/* Show startup message */
void showStartup() {
  printf("ADAPA (Automatic DAta PArallelism) - Version: %s (LINUX)\n", VERSION);
  printf("Copyright (C) %d  %s\n", YEAR, AUTHOR);
  puts("[This version only works with Condor Submission Engine - Vanilla jobs]");
  puts("\nThis program comes with ABSOLUTELY NO WARRANTY.");
  puts("This is free software, and you are welcome to redistribute it\n"
       "under certain conditions.");
    puts("For details see the GPLv3 license that came with the program (\"COPYING\")\n");
}

// --------------------------------------

/* Main function */
int main(int argc, char **argv) {

  showStartup();
  p.doParameters(argc, argv);
  p.msgState();
  
  Action a(&p);
  a.decideAction();

  return 0;
}
