/*
This file is part of Adapa (Automatic DAta PArallelism)
Copyright (C) 2009  Pedro Ribeiro (CRACS & INESC-Porto LA, U. Porto)

Adapa is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License version 3, as
published by the Free Software Foundation.

Adapa is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Adapa.  If not, see <http://www.gnu.org/licenses/>.
*/
 
#ifndef _ENGINE_
#define _ENGINE_

#include "Parameters.h"

class Engine {

 public:
  virtual void setParameters(Parameters *p) = 0;
  virtual void prepareFiles() = 0;
  virtual void submit() = 0;
  virtual void cancel() = 0;
  virtual void status() = 0;
  virtual int jobsRunning() = 0;
  virtual void rerun(int i) = 0;
  
  virtual ~Engine() {};
};

#endif
