/*
This file is part of Adapa (Automatic DAta PArallelism)
Copyright (C) 2009  Pedro Ribeiro (CRACS & INESC-Porto LA, U. Porto)

Adapa is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License version 3, as
published by the Free Software Foundation.

Adapa is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Adapa.  If not, see <http://www.gnu.org/licenses/>.
*/
 
#ifndef _PARAMETERS_
#define _PARAMETERS_

#include <map>
#include <string>

using namespace std;

class Parameters {
 public:
  map<string, string> arg;
  bool verbose, transfer_files;
  int nr_values, nr_channels, nr_partitions;
  int bytes_per_value;
  int *start, *end;
  string *channel;
  string **part_channel;
  string *part_input, *part_output, *part_log;

  void initDefaultParameters();
  void parseParameters(int argc, char **argv);
  void readExperimentConfigFile();
  void writeExperimentConfigFile();
  void readArgumentConfigFile();
  void readConfigFile(const char *s);
  void writeConfigFile(const char *s);
  void enableValues();
  void enableParameters();

  void doParameters(int argc, char **argv);
  void showUsage();
  void msgState();
};

#endif
